<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SeatGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SeatGroup extends AbstractStructArrayBase
{
    /**
     * The SeatGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SeatGroup[]
     */
    public $SeatGroup;
    /**
     * Constructor method for ArrayOfJP_SeatGroup
     * @uses ArrayOfJP_SeatGroup::setSeatGroup()
     * @param \StructType\JP_SeatGroup[] $seatGroup
     */
    public function __construct(array $seatGroup = array())
    {
        $this
            ->setSeatGroup($seatGroup);
    }
    /**
     * Get SeatGroup value
     * @return \StructType\JP_SeatGroup[]|null
     */
    public function getSeatGroup()
    {
        return $this->SeatGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatGroupForArrayConstraintsFromSetSeatGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SeatGroupSeatGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SeatGroupSeatGroupItem instanceof \StructType\JP_SeatGroup) {
                $invalidValues[] = is_object($arrayOfJP_SeatGroupSeatGroupItem) ? get_class($arrayOfJP_SeatGroupSeatGroupItem) : sprintf('%s(%s)', gettype($arrayOfJP_SeatGroupSeatGroupItem), var_export($arrayOfJP_SeatGroupSeatGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatGroup property can only contain items of type \StructType\JP_SeatGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatGroup[] $seatGroup
     * @return \ArrayType\ArrayOfJP_SeatGroup
     */
    public function setSeatGroup(array $seatGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($seatGroupArrayErrorMessage = self::validateSeatGroupForArrayConstraintsFromSetSeatGroup($seatGroup))) {
            throw new \InvalidArgumentException($seatGroupArrayErrorMessage, __LINE__);
        }
        $this->SeatGroup = $seatGroup;
        return $this;
    }
    /**
     * Add item to SeatGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SeatGroup $item
     * @return \ArrayType\ArrayOfJP_SeatGroup
     */
    public function addToSeatGroup(\StructType\JP_SeatGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SeatGroup) {
            throw new \InvalidArgumentException(sprintf('The SeatGroup property can only contain items of type \StructType\JP_SeatGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SeatGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SeatGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SeatGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SeatGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SeatGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatGroup
     */
    public function getAttributeName()
    {
        return 'SeatGroup';
    }
}
